<?php
/**
 * Landofcoder
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Landofcoder.com license that is
 * available through the world-wide-web at this URL:
 * http://landofcoder.com/license
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category   Landofcoder
 * @package    Lof_SocialLogin
 *
 * @copyright  Copyright (c) 2016 Landofcoder (http://www.landofcoder.com/)
 * @license    http://www.landofcoder.com/LICENSE-1.0.html
 */

namespace Lof\SocialLogin\Model;

use Magento\Framework\ObjectManagerInterface;

require_once BP. '/vendor/lof/sociallogin-lib/Oauth2/service/Google_ServiceResource.php';
require_once BP. '/vendor/lof/sociallogin-lib/Oauth2/service/Google_Service.php';
require_once BP. '/vendor/lof/sociallogin-lib/Oauth2/service/Google_Model.php';
require_once BP. '/vendor/lof/sociallogin-lib/Oauth2/contrib/Google_Oauth2Service.php';
require_once BP. '/vendor/lof/sociallogin-lib/Oauth2/Google_Client.php';
restore_error_handler();

class Google extends \Google_Client
{

    protected $config;
    protected $objectManagerInterface;

    public function __construct(

                $config = []
    ) {
    
        $this->config = new \Google_Client();
        $this->config->setClientId($this->getGoogleHelper()->getClientId());
        $this->config->setClientSecret($this->getGoogleHelper()->getClientSecret());
        $this->config->setRedirectUri($this->getBaseUrl());
    }

    public function getGoogleHelper()
    {
        $objectmanager     = \Magento\Framework\App\ObjectManager::getInstance();
        $helper = $objectmanager->create('Lof\SocialLogin\Helper\Google\Data');

        return $helper;
    }

    public function getConfig($name, $default = null)
    {
        return $this->config;
    }
    public function getBaseUrl()
    {
        $objectmanager     = \Magento\Framework\App\ObjectManager::getInstance();
        $helper = $objectmanager->get('Magento\Store\Model\StoreManagerInterface')
        ->getStore()
        ->getBaseUrl();

        return $helper.'lofsociallogin/google/callback';
    }
}
